*****************************************************************************
* Name:		TREE
* Type:		Library
* Platform:	HP48G/G+/GX
* Language:	System RPL / Assembly Language
* Author:	Raul del cid Lopez, Guatemala C.A.
* Copyright :
*	(c) 2000-2001 by Raul del Cid Lopez. ALL rights reserved.
*
* Description:
*	Fast application to Display and Navigate through the directories
*	inside your HP48 in a Windows's Explorer-like Tree.
*
* Uses:
*	- Library  257: UFL Font Lev. 1
*
* Version History:
* 1.1  Feb/22/2001  Raul
* 1.2  Mar/12/2001  Raul & Raymond Hellstern
* 1.3  Sep/08/2201  Raul
*****************************************************************************

xROMID	445
xTITLE	TREE 1.3 Sep 2001
xCONFIG	TreeCfg


EXTERNAL xTREE
EXTERNAL DirIndexDrw
EXTERNAL Slider


LABEL TreeCfg
::
  445 TOSRRP
 ;


********** TREE VARS ************
DEFINE Tmin@		10GETLAM
DEFINE Tmin!		10PUTLAM
DEFINE Tn@		9GETLAM
DEFINE Tn!		9PUTLAM
DEFINE Tdy@		8GETLAM
DEFINE Tdy!		8PUTLAM
DEFINE TbarHeight@	7GETLAM
DEFINE TbarHeight!	7PUTLAM
DEFINE Tmax@		6GETLAM
DEFINE Tmax!		6PUTLAM
DEFINE Tpos@		5GETLAM
DEFINE Tpos!		5PUTLAM
DEFINE Tindex@		4GETLAM
DEFINE Tindex!		4PUTLAM
DEFINE TindexPtr@	3GETLAM
DEFINE TindexPtr!	3PUTLAM
DEFINE T{}Dirs@		2GETLAM
DEFINE T{}Dirs!		2PUTLAM
DEFINE TminiFont@	1GETLAM
*********************************


ASSEMBLE
	TITLE TREE v1.3
invFont	EQU 3	Invert Font?
RPL


NIBB 1 8
xNAME TREE
::
  ERRSET
  ::
  ONE EIGHT NDUPN
  ROMPTR 101 3

  ' NULLLAM TEN NDUPN DOBIND

  TWENTYSEVEN CREATEHXS ( Tokens )

  GARBAGE
****************************** DIR-TREE ENGINE ******************************
*  1:	$tokens   ->   { "Home (\)"...} Complete Dir-List
*
*  5 Nibbs(Dir-offset) + 22 Nibbs(tokens) = 27 Nibbles
*  
* Tokens:  0=" "  /  1=""  /  2=""  /  3=""  /  4=".."
*
* R0[A]= ->List
* R1[A]= Home's Last Object Offset, for Stop-Sign
* R2[A]= ->Tokens = 00000 0 0 0 0 0 0 0 0 0 0 0 0...
* R3[A]= ->DIR, saves current dir been analyzed
* R4[A]= #Level_Depth
*****************************************************************************
  CODE

Match		EQU 0	Directory Match?
lastDir		EQU 1	Last directory?

		STITLE	Directory TREE
		GOSBVL	=DisableIntr
		GOSBVL	=SAVPTR
		GOSBVL	=ROOM
		A=C	A
		C=0	A
		LC(2)	200
		C=A-C	A
		GOC	memError
		GOSBVL	=GETTEMP
		D=C	A		D[A]= Free RAM
		GOSUB	{}Header
		CON(5)	=DOLIST
		CON(5)	=DOCSTR
		CON(5)	5+16
		NIBASC	\Home (\\)\
{}Header	C=RSTK
		CD0EX
		D1=C
		R0=C			R0[A]= -> new{}
		C=0	A
		LC(2)	5+26+5		alloc { "Home (\)" }
		D=D-C	A
		GONC	+
memError	GOVLNG	=GPMEMERR
+		C=C-CON A,5		Set SEMI separtely
		GOSBVL	=MOVEDOWN
		C=0	A
		R4=C			Reset #Level_Depth
		GOSBVL	=D0=DSKTOP
		A=DAT0	A
		A=A+CON A,10		skip prolog & field
		R2=A			R2[A]= ->$tokens
		D0=A
		DAT0=C	A		Reset Dir-offset
		D0=(5)	=USEROB
		A=DAT0	A
		D0=A			D0 ->HomeDir
		ST=0	Match
		GOSUB	dirMatch?
		D0=D0+	5
		C=DAT0	A
-		C=C-1	X		-+
		GOC	+		 
		D0=D0+	13		 - Skip Home's attached Libraries
		GONC	-		 
+		D0=D0+	3		-+
		C=DAT0	A
		R1=C			R1[A]= Home's last object offset
		GOTO	InvLink
**********************************************************************
dirMatch?	?ST=1	Match		Match already found?
		RTNYES
		C=R2.F	A
		CD0EX			Save ->DIR
		A=DAT0	A		-+
		A=A+1	A		 - Increase DIR offset
		DAT0=A	A		-+
		D0=(5)	=CONTEXT	D0 -> current Dir
		A=DAT0	A
		D0=C			Restore ->DIR
		?A#C	A		Current Dir?
		RTNYES			No, return
		ST=1	Match		Yes, Don't test this again!
		RTN
**********************************************************************
Level--		C=R4.F	A		-+
		C=C-1	A		 - Decrease Level Depth
		R4=C.F	A		-+
		RTNCC
**********************************************************************
dirScan!	GOSUB	dirMatch?	Match this dir
		CD0EX
		R3=C.F	A		R3[A]= Save ->DIR
		GOSUB	Level++
		C=R3.F	A		get -> DIR
		DAT1=C	A		write dir pointer
		D1=D1+	5
		D0=C			Restore D0 -> DIR
		D0=D0+	8
		C=DAT0	A
		?C#0	A		Empty Dir?
		GOYES	InvLink
		GOSUB	Level--
		GONC	continue
InvLink		C=-C	A
**********************************************************************
nxtVarLp	?C=0	A		Link=0?
		GOYES	upDir
		AD0EX
		A=A-C	A
		B=A	A		B[A]= Save ->Name
		D0=A			D0 -> Name
		GOSBVL	=TRAVERSE+
		A=DAT0	A
		LC(5)	=DORRP
		?A=C	A		Is it a Dir?
		GOYES	dirScan!	yes, go and Scan it!
continue	A=B	A		Restore ->Name
		D0=A
linkChk		D0=D0-	5
		C=DAT0	A		C[A]= ->next Link
		GOTO	nxtVarLp
**********************************************************************
upDir		D0=D0-	5
		C=DAT0	A		Read last Object offset
		A=R1.F	A
		?A=C	A		Are we Home Yet?
		GOYES	ScanDone
		GOSUB	Level--
		D0=D0-	8		D0 -> DIR
		GOSBVL	=TRAVERSE-
		GOTO	linkChk
**********************************************************************
ScanDone	LC(5)	=SEMI
		DAT1=C	A
		D1=D1+	5
		AD1EX
		D0=A			A, D0 = List End
		GOSBVL	=ShrinkOb
		GOSBVL	=AllowIntr
		GOSBVL	=GETPTR
		C=R0
		DAT1=C	A		over Write List
		C=R2
		D0=C
		A=DAT0	A		read Dir offset
		GOVLNG	=PUSH#ALOOP
**********************************************************************
Level++		A=R4.F	A		-+
		A=A+1	A		 -Increase Level Depth
		R4=A.F	A		-+
		A=A-1	A
		?A=0	A
		GOYES	LASTDIR?
		C=0	A
		LC(2)	22
		?A>C	A
		GOYES	LASTDIR?
		C=R2.F	A
		C=C+A	A
		D0=C
		D0=D0+	5-1		skip Dir offset
		A=DAT0	P		read current Token
		LC(1)	0		Load " " token
		?A=C	P
		GOYES	LASTDIR?
		LC(1)	2		Load "" token
		?A=C	P
		GOYES	LASTDIR?
		LC(1)	1		Load "" token
		?A=C	P
		GOYES	+
		LC(1)	2		Load "" token
		GONC	tokenWr
+		C=0	A		Load " " token
tokenWr		DAT0=C	P
**********************************************************************
* Now we have to check if R3 dir is the last inside it's context
**********************************************************************
LASTDIR?	ST=0	lastDir
		C=R3.F	A
		D0=C
LnkCheck	GOSBVL	=TRAVERSE-
		D0=D0-	5
		C=DAT0	A
nxtDirLp	?C#0	A
		GOYES	+
		ST=1	lastDir
		GONC	TokensCpy
+		AD0EX
		A=A-C	A
		D0=A
		GOSBVL	=TRAVERSE+
		A=DAT0	A
		LC(5)	=DORRP
		?A#C	A
		GOYES	LnkCheck
**********************************************************************
TokensCpy	C=R2.F	A
		D0=C			D0 ->$tokens
		D0=D0+	5-1		skip Dir offset
		A=R4.F	A		Read Level Depth
		C=0	A
		LC(2)	22
		?A<=C	A		Level depth <= 22?
		GOYES	+
		A=C	A		set Level depth= 22
		LC(1)	4		Load ".." token
		GONC	tokWr
+		LC(1)	3		Load "" token
		?ST=0	lastDir
		GOYES	tokWr
		LC(1)	1		Load "" token
tokWr		CD0EX
		C=C+A	A
		CD0EX
		DAT0=C	P		Write last Token
		C=A	A		C[A]= level depth
		C=C+CON A,15		+ prlg + size + dirPtr
		D=D-C	A
		GONC	+
		GOTO	memError
+		LA(5)	=DOHSTR
		DAT1=A	A
		D1=D1+	5
		C=C-CON A,5		remove prlg size from field
		DAT1=C	A
		D1=D1+	5
		A=R2.F	A
		D0=A
		D0=D0+	5		skip Dir-offset
		C=C-CON A,10		copy Tokens only
		GOVLNG	=MOVEDOWN
*****************************************************************************
  ENDCODE

  Tindex!
  DUPLENCOMP Tn!
  T{}Dirs!

  RECLAIMDISP
  TURNMENUOFF
  ClrDA1IsStat

  ( Title )
  "TREE"
  ROMPTR 0E0 044

  ( Menu Labels )
  "OK"
  "(AN(L"
  NULL$ DUPDUP DUP

  SIX
  ZERO_DO
    MakeStdLabel
    ABUFF
    INDEX@ TWENTYTWO #* FIFTYSIX
    GROB!
  LOOP

  Tn@ EIGHT #>ITE ::
		    EIGHT Tindex@ #MAX
		    DUP SEVEN #- Tmin!
		   ;
		  Tn@
  Tmax!

  ( Compute Slider settings )
  ::
    Tn@ NINE #< ?SEMI

    Tn@ UNCOERCE % 46 DUP3PICK %8 %T %OF
    %2 %MAX
    DUP COERCE TbarHeight!
    %- SWAP %8 %- %/ Tdy!
    Slider
   ;

  Tindex@ Tmin@ #-+1
  Tpos!

  T{}Dirs@ Tmin@ Tmax@ SUBCOMP
  INNERCOMP
  reversym

  #1+_ONE_DO
    INDEX@
    Tindex@ Tmin@ #-+1 OVER#=
*********************************************************************************
* This routine displays the given directory directly on screen, at the position
* specified, it adds the Dir Icon to the Name
*
* 3:   hxsTokens  (Tokens + ->Directory)
* 2:  #pos (1-8)  (position in Screen)
* 1:	 Invert?  (Invert the Font?)		->
*********************************************************************************
CODE
		STITLE	Path > Screen
**********************************
TPath>DispLp	GOSUB	TPath>Disp
		GOVLNG	=Loop
**********************************
TPath>Disp	CLRST
		GOSBVL	=popflag
		GONC	+
		ST=1	invFont
+		GOSBVL	=POP#
		R4=A			Save #pos
		GOSBVL	=PopASavptr
		A=A+CON A,5
		R3=A			R3[A]= "xxx DIRptr"
**********************************
		D1=(5)	=TEMPENV	Read miniFont from LAM #1
		A=DAT1	A
		D1=A
		D1=D1+	1*10+5
		A=DAT1	A
		A=A+CON	A,10
		R0=A			R0[A]= ->miniFont
**********************************
		C=0	A
		LC(2)	34
		B=C	A		B[A]= Nibbs for next Line
		GOSUB	D0->Row1(R4)
		C=R3
		D1=C			D1 -> "xxx DIRptr"
		D1=D1-	5
		A=DAT1	A
		LC(5)	=DOHSTR
		?A=C	A		Is it a Hex-String?
		GOYES	ToksBuild
**********************************************************************
* Only a "string"
**********************************************************************
		CD1EX
		GOSUB	C$>miniFont
		C=0	A
		LC(2)	24
		GOSUB	F48WipeOut
		GOVLNG	=GETPTR
*********************************************************************
* You can switch Tokens to See wich one looks Better!
*		NIBHEX	000000117000111111117111000050
**********************************************************************
ToksBuild	GOSUB	TokAdr
		NIBHEX	000000226000222222226222000050
TokAdr		C=RSTK
		R1=C			R1[A]= ->TokensFont
		D1=D1+	5		->Hex$ size field
		C=DAT1	A
		D1=D1+	5		->Tokens
		C=C-CON A,10		- size field and - DIR address
		R2=C			R2=# of tokens
		D=C	A		D[B]= # of tokens
nxtTokenLp	D=D-1	B
		GOC	putDirIcon
		A=0	A
		A=DAT1	P		Read 1 Token
		A=A+A	A
		C=R1.F	A		C[A]= Read Token's Font
		C=A+C	A
		C=A+C	A
		C=A+C	A
		CD0EX			D0 -> Char Font data
		A=DAT0	6
		D0=C
nxtTokLine	DAT0=A	P
		CD0EX
		C=C+B	A
		CD0EX
		P=P+1
		?P#	6
		GOYES	nxtTokLine
		P=	0
		D0=C
		D0=D0+	1
		D1=D1+	1		-> next Token
		GOTO	nxtTokenLp
**********************************************************************
putDirIcon	AD0EX
		D0=A			Save D0
		LCHEX	007F41417F0E	Load dir Icon
		P=	16-6
IconLp		DAT0=C	B
		CSR	W
		CSR	W
		CD0EX
		C=C+B	A
		CD0EX
		P=P+1
		GONC	IconLp
		D0=A			Restore D0
		D0=D0+	2		skip dir Icon
**********************************************************************
putDirName	C=DAT1	A
		D1=C			D1 ->DIR
		D1=D1-	2		D1 ->Second Name's field
		C=0	A
		C=DAT1	B
		D=C	A		D[A]= Save # of Chars
		?C#0	B
		GOYES	+
		LC(2)	34		Load char 34 ( " )
		A=C	A
		GOSUB	oneChar
		D1=D1-	2		Ensure D1 ->nameLength
		GONC	ClearLast
+		C=C+C	A
		AD1EX
		A=A-C	A
		D1=A			D1 -> Chars
		C=R3			C[A]= "xxx DIRptr"
		CD1EX
		A=DAT1	A
		D1=C			Restore D1 -> Chars
		A=A-CON A,10-2		A[A]= #Tokens (-DirIcon)
		C=0	A
		LC(2)	32
		C=C-A	A		Name Max Lenght= 32 - #Tokens
		?D<=C	A		Name lenght Ok?
		GOYES	+
		D=C	A		Set Max Name lenght
+		GOSUB	nxtChrLp
**********************************************************************
ClearLast	C=0	A
		LC(2)	32
		A=R2			get # of tokens
		C=C-A	B		- #tokens
		C=C-CON	B,2		- dirIcon
		A=DAT1	B		read #chars
		?A#0	B
		GOYES	+
		A=A+1	B		if Nullid, ensure 1 char (")
+		C=C-A	B		Blank=32-#toks-dirIcon-#chars
		GOC	+
		GOSUB	F48WipeOut
+		GOVLNG	=GETPTR
**********************************************************************
C$>miniFont	GOSBVL	=GetStrLenC
D1>miniFont	D=C	A
nxtChrLp	D=D-1	A
		GONC	+
		RTNCC
+		A=0	A
		A=DAT1	B		Read 1 char
oneChar		A=A+A	A
		C=R0.F	A		C[A]= Chars Font
		C=A+C	A
		C=A+C	A
		C=A+C	A
		CD0EX			D1 -> Char Font data
		A=DAT0	6
		D0=C
		?ST=0	invFont
		GOYES	nxtLine
		P=	5
		A=-A-1	WP		Invert the Char Font
		P=	0
nxtLine		DAT0=A	P
		CD0EX
		C=C+B	A
		CD0EX
		P=P+1
		?P#	6
		GOYES	nxtLine
		P=	0
		D0=C
		D0=D0+	1
		D1=D1+	2
		GOTO	nxtChrLp
**********************************************************************
* Wipe/Clear C[A] Nibbles at D0 (covers 6 Lines down)
* Uses: D0,A,C,D,R2
**********************************************************************
F48WipeOut	C=C-1	A
		GOC	Return
		D=C	A
		LC(2)	5
		CDEX	A		D[B]=loop counter
		A=0	W
		P=C	0
		R2=C			R2[A]= Nibbs to Wipe/Clear
**********************************
LineWipeLp	C=R2			Recover Nibbs
		CSR	A		Nibbs / 16
		C=C-1	A
		GOC	WipeLast
WipeLp		DAT0=A	W
		D0=D0+	16
		C=C-1	A
		GONC	WipeLp
WipeLast	DAT0=A	WP
**********************************		
		CD0EX
		C+P+1			advance Nibbs<16
		C=C-1	A		-1 because of above instruction
		C=C+B	A		->nextLine
		AR2EX
		C=C-A	A
		AR2EX
		D0=C			->Disp to Wipe
		D=D-1	B
		GONC	LineWipeLp
**********************************
Return		P=	0
		RTNCC
**********************************************************************
* D0 ->Disp + ( ( A*6 + 2 )*34 )
**********************************************************************
D0->Row1(R4)	A=R4
D0->Row1(A)	A=A+A	A	bint * 2
		C=A	A
		C=C+A	A
		C=C+A	A	bint * 6
		C=C+1	A
		C=C+1	A	(bint * 6) + 2
		C=C+C	A
		A=C	A
		ASL	A
		C=C+A	A	((bint * 6) + 2 ) * 34
		D0=(5)	#8068D
		A=DAT0	A
		A=A+C	A
		D0=A
		RTN
**********************************************************************
ENDCODE
  LOOP

  T{}Dirs@ Tindex@ NTHCOMPDROP
  TindexPtr!

  BEGIN
    { FIVE SIX TWENTYFIVE FORTYFIVE ELEVEN SEVENTEEN }
    GETKEY* ?SKIP DROPZERO
    EQUALPOSCOMP
    DUP#0=ITE
    DROPFALSE
    ::
      {
	FalseTrue   ( CANCEL )
	TrueTrue    ( OK )
	TrueTrue    ( ENTER )
	FalseTrue   ( ON )
		 :: ( UP )
		   BEGIN
		     Tindex@ Tmin@
		     #=ITE
		     ::
		       Tindex@ #1= ?SEMI ( Window Top? )
		       Tmin@ DUP#1- Tmin! #6+ Tmax!
		       Tindex@ #1- Tindex!

		       CODE
LAMTIndexPtr EQU #3
GetPrev<-Dir			GOSUB	GetIndxPtr
				D0=D0-	15
-				D0=D0-	1
				A=DAT0	A
				LC(5)	=DOHSTR
				?A=C	A
				GOYES	PushDir
				LC(5)	=DOCSTR
				?A#C	A
				GOYES	-
PushDir				AD0EX
				GOVLNG	=GPPushALp
***********************************************************************
GetIndxPtr			GOSBVL	=SAVPTR
				D0=(5)	=TEMPENV
				A=DAT0	A
				C=0	A
				LC(2)	(LAMTIndexPtr)*10+5
				A=A+C	A
				D0=A			D0 ->&Object
				C=DAT0	A
				D0=C			D0 ->Object
				RTN
		       ENDCODE

		       ONE TRUE
		       TindexPtr@ 4PICK TindexPtr!
		       TWO FALSE
**********************************************************************
* Completely Refresh the Screen!
**********************************************************************
		       CODE
				ST=0	15		ON key disabled!
				GOSBVL	=SAVPTR
				D0=(5)	#8068D
				A=DAT0	A
				LC(5)	56*34
				C=C+A	A
				D1=C
				LC(5)	50*34
				C=C+A	A
				D0=C
				LC(2)	36-1		Lines to copy
				B=C	A
copyLineUp			D0=D0-	2		->PreviousLine
				D1=D1-	2		->PreviousLine
				C=0	A
				LC(2)	32		32 Nibbles to copy
				GOSBVL	=MOVEUP
				B=B-1	B
				GONC	copyLineUp
				GOSBVL	=GETPTR
				GOSUB	TPath>Disp
				GOTO	TPath>DispLp
		       ENDCODE
**********************************************************************
		       Slider
		      ;
		     ::
		       Tindex@ #1- Tindex!
		       CODE
				GOTO	GetPrev<-Dir
		       ENDCODE
		       Tpos@ #1-
		       DirIndexDrw
		      ;
		     ELEVEN REPKEY?
		   NOT_UNTIL
		   FALSE
		  ;

		 :: ( DOWN )
		   BEGIN
		     Tindex@ Tmax@
		     #=ITE
		     ::
		       Tindex@ Tn@ #= ?SEMI ( Window bottom? )
		       Tindex@ #1+ Tindex!
		       Tmin@ #1+DUP Tmin! #7+ Tmax!

		       CODE
GetNextDir->			GOSUB	GetIndxPtr
				GOSBVL	=SKIPOB
				AD0EX
				GOVLNG	=GPPushALp
		       ENDCODE
                                
		       EIGHT TRUE
		       TindexPtr@ 4PICK TindexPtr!
		       SEVEN FALSE
**************************************************************************
* Completely Refresh the Screen!
**************************************************************************
		       CODE
				ST=0	15		ON key disabled!
				GOSBVL	=SAVPTR
				D0=(5)	#8068D
				A=DAT0	A
				LC(5)	8*34
				C=C+A	A
				D1=C
				LC(5)	14*34
				C=C+A	A
				D0=C
				LC(2)	36-1		Lines to copy
				B=C	A
copyLineDown			C=0	A
				LC(2)	32		32 Nibbles to copy
				GOSBVL	=MOVEDOWN
				D0=D0+	2		->nextLine
				D1=D1+	2		->nextLine
				B=B-1	B
				GONC	copyLineDown
				GOSBVL	=GETPTR
				GOSUB	TPath>Disp
				GOTO	TPath>DispLp
		       ENDCODE
**************************************************************************
		       Slider
		      ;
		     ::
		       Tindex@ #1+ Tindex!
		       CODE
				GOTO	GetNextDir->
		       ENDCODE
		       Tpos@ #1+
		       DirIndexDrw
		      ;
		     SEVENTEEN REPKEY?
		   NOT_UNTIL
		   FALSE
		  ;
      }
      SWAP NTHCOMPDROP COLA_EVAL
     ;
  UNTIL
  ITE ::
	TindexPtr@
	DUPTYPEHSTR?
	ITE CODE
		GOSBVL	=SAVPTR
		A=DAT1	A
		D0=A
		GOSBVL	=SKIPOB
		D0=D0-	5
		A=DAT0	A
		GOVLNG	=GPPushALp
	    ENDCODE
	    SYSCONTEXT@
	SWAPDROPTRUE
       ;
      FALSE
  ABND
  ;
  ERRTRAP
  ERRJMP
  ClrDAsOK
 ;



NULLNAME DirIndexDrw
::
  TindexPtr@ Tpos@ FALSE
  5ROLL DUP TindexPtr!
  5ROLL DUP Tpos!
  TRUE
  CODE
	GOSUB	TPath>Disp
	GOTO	TPath>DispLp
  ENDCODE
 ;



NULLNAME Slider
::
  Tdy@ Tmin@ #1- UNCOERCE %* COERCE  ( Y Pos )
  TbarHeight@			     ( Bar Height )
  CODE
	GOSBVL	=POP2#
	R0=A			* R0[A]= #Y pos
	R1=C			* R1[A]= #vertHeight
	GOSBVL	=SAVPTR

* Prepare D1 ->offset in Screen

	D1=(5)	#8068D
	A=DAT1	A
	LC(5)	9*34
	A=A+C	A		* advance 9 Rows
	D1=A
	D1=D1-	2		* ->Disp, just for Slider!

* Start drawing:  frame, blank space and bar!

	GOSUB	1Black		* Write Top Line
	A=R0
	?A=0	A		* Bar at Top?
	GOYES	+		* yep, no leading space
	A=A-1	A
	GOSUB	White		* Write leading blank space
+	A=R1
	A=A-1	A
	GOSUB	Black		* Write Bar

* Now compute & draw final white space

	C=0	A
	LC(2)	46-1		* BarSize
	A=R0
	C=C-A	A
	A=R1
	C=C-A	A		* Final=BarSize-Y-vertHeight
	GOC	+		* just in case of underflow...
	ACEX	A
	GOSUB	White		* Write final blank space
+	GOSUB	1Black		* Write bottom Line
	GOVLNG	=GETPTRLOOP
***************************
* #5= 0101 pixels
* #7= 0111 pixels
***************************
White	LCHEX	5
	GONC	BarLp
1Black	A=0	A
Black	LCHEX	7
BarLp	DAT1=C	P
	D1=D1+	16
	D1=D1+	16
	D1=D1+	2		* D1 ->nextLine
	A=A-1	A
	GONC	BarLp
	RTNCC
  ENDCODE
 ;
